/*******************************************************************************
 * FoxDamageType generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDamageType extends DamageType
    abstract
    native;

struct native DamageProtectionInfo
{
    var FoxTypes.EDamageReductionType ProtectionType;
    var string ProtectionIcon;

    structdefaultproperties
    {
        ProtectionType=EDamageReductionType.EDRT_None
        ProtectionIcon=""
    }
};

var bool bIgnoreCover;
var bool bIgnoreDamageMultipliers;
var const bool bIsSuicideDamageType;
var const bool bCanInjure;
var const bool bAllowDecapitation;
var const bool bIndirectDamage;
var const bool bSpecialtyDamage;
var const bool bPermanentDamage;
var const bool bDamageFriendlies;
var() array<float> DamageZoneMultipliers;
var() array<float> DamageZoneMomentumMultipliers;
var const float DamagePercentageConsumed;
var const float CameraShakeMultipler;
var class<FoxWeapon> InstigatingClass;
var const localized array<localized string> KillStrings;
var const localized array<localized string> SuicideStrings;
var const string StatusDialogName;
var const string StatName;
var const transient class<FoxCameraLensEffect_Base> LensEffectClass;
var const string IndirectColor;
var const string IndirectGlow;
var const string IndirectIcon;
var const string ProtectionColor;
var const string ProtectionGlow;
var const array<DamageProtectionInfo> ProtectionInfo;
var const FoxTypes.EDamageReductionType ProtectionType;
var const FoxTypes.EHitType BodyHitType;
var const FoxTypes.EHitType HardSuitHitType;
var const FoxTypes.EHitType HardSuitWPHitType;

// Export UFoxDamageType::execGetDamageMultiplier(FFrame&, void* const)
native static function float GetDamageMultiplier(const int DamageZone);

// Export UFoxDamageType::execGetMomentumMultiplier(FFrame&, void* const)
native static function float GetMomentumMultiplier(const int DamageZone);

// Export UFoxDamageType::execGetKillString(FFrame&, void* const)
native static function string GetKillString(FoxPRI KilledPRI, PlayerController PC, optional bool bHTMLText)
{
    bHTMLText = true;                    
}

// Export UFoxDamageType::execGetSuicideString(FFrame&, void* const)
native static function string GetSuicideString();

static function ApplyEffect(FoxPawn VictimPawn, out int DamageAmount, optional Controller ControllerInstigator)
{
    local float PermanentHealthDamageAmount;

    DamageAmount *= FMax(0.0, (GetBoostDamageMultiplier(ControllerInstigator)) * (GetPawnDamageReduction(VictimPawn)));
    // End:0x67
    if(default.DamagePercentageConsumed > float(0))
    {
        DamageAmount *= (1.0 - default.DamagePercentageConsumed);
    }
    // End:0xCC
    if(default.bPermanentDamage)
    {
        PermanentHealthDamageAmount = FMax(0.0, float(DamageAmount) * (GetPawnPermanentHealthDamageReduction(VictimPawn)));
        AddPermanentHealthDamage(VictimPawn, int(PermanentHealthDamageAmount), default.Class);
    }
    //return;    
}

static function AddLensEffect(FoxPawn VictimPawn, int DamageAmount)
{
    // End:0x9F
    if(((default.LensEffectClass != none) && DamageAmount > 0) && VictimPawn.IsLocallyControlled())
    {
        FoxPC(VictimPawn.Controller).PlayerCamera.AddCameraLensEffect(default.LensEffectClass);
    }
    //return;    
}

static function float GetPawnPermanentHealthDamageReduction(FoxPawn VictimPawn)
{
    // End:0x2E
    if(VictimPawn != none)
    {
        return VictimPawn.PermanentHealthProtection;
    }
    return 1.0;
    //return ReturnValue;    
}

static function float GetPawnDamageReduction(FoxPawn VictimPawn)
{
    // End:0xCB
    if((VictimPawn != none) && default.ProtectionType != 0)
    {
        switch(default.ProtectionType)
        {
            // End:0x5C
            case 4:
                return VictimPawn.IncendiaryProtection;
            // End:0x80
            case 1:
                return VictimPawn.ToxicProtection;
            // End:0xA4
            case 2:
                return VictimPawn.ExplosiveProtection;
            // End:0xC8
            case 3:
                return VictimPawn.ElectroProtection;
            // End:0xFFFF
            default:
            }
            return 1.0;
            //return ReturnValue;            
}

static function bool GetPawnDamageProtectionIcon(out string ProtectionIcon)
{
    local int Index;

    Index = default.ProtectionInfo.Find('ProtectionType', default.ProtectionType);
    // End:0x6E
    if(Index != -1)
    {
        ProtectionIcon = default.ProtectionInfo[Index].ProtectionIcon;
        return true;
    }
    return false;
    //return ReturnValue;    
}

static function float GetBoostDamageMultiplier(Controller ControllerInstigator)
{
    // End:0x43
    if(FoxPC(ControllerInstigator) != none)
    {
        return FoxPC(ControllerInstigator).GetMultiplierForBoost(5);
    }
    return class'FoxPRI'.default.DefaultPersonalModifier.BoostMultiplier;
    //return ReturnValue;    
}

static function FoxTypes.EHitType GetHitType(bool bHeadShot)
{
    // End:0x38
    if((bHeadShot && !default.bIgnoreDamageMultipliers) && default.DamageZoneMultipliers[1] > 1.0)
    {
        return 2;
    }
    return default.BodyHitType;
    //return ReturnValue;    
}

static function FoxTypes.EHitType GetHardSuitHitType(bool bWeakPoint)
{
    // End:0x17
    if(bWeakPoint)
    {
        return default.HardSuitWPHitType;
    }
    return default.HardSuitHitType;
    //return ReturnValue;    
}

static function AddPermanentHealthDamage(FoxPawn VictimPawn, int DamageAmount, class<FoxDamageType> PermanentDamageType)
{
    // End:0x55
    if(!VictimPawn.bIsMachine)
    {
        VictimPawn.TakePermanentHealthDamage(DamageAmount, PermanentDamageType);
    }
    //return;    
}

defaultproperties
{
    bCanInjure=true
    DamageZoneMultipliers(0)=1.0
    DamageZoneMultipliers(1)=1.0
    DamageZoneMultipliers(2)=1.0
    DamageZoneMultipliers(3)=1.0
    DamageZoneMultipliers(4)=1.0
    DamageZoneMultipliers(5)=1.0
    DamageZoneMultipliers(6)=1.0
    DamageZoneMultipliers(7)=1.0
    DamageZoneMultipliers(8)=1.0
    DamageZoneMultipliers(9)=1.0
    CameraShakeMultipler=1.0
    ProtectionColor="0xFFFFFF"
    ProtectionGlow="0xFFFFFF"
    ProtectionInfo(0)=(ProtectionType=EDamageReductionType.EDRT_IncendiaryAmmoDamageReduction,ProtectionIcon="UI_Icons.Gear.t_incendiaryArmor")
    ProtectionInfo(1)=(ProtectionType=EDamageReductionType.EDRT_ToxicAmmoDamageReduction,ProtectionIcon="UI_Icons.Gear.t_toxicArmor")
    ProtectionInfo(2)=(ProtectionType=EDamageReductionType.EDRT_ExplosiveAmmoDamageReduction,ProtectionIcon="UI_Icons.Gear.t_explosiveArmor")
    ProtectionInfo(3)=(ProtectionType=EDamageReductionType.EDRT_ElectricAmmoDamageReduction,ProtectionIcon="UI_Icons.Gear.t_shockArmor")
    bSuppressDeathMessage=true
    bAwardNoPoints=true
    KDeathUpKick=800.0
    begin object name=ForceFeedbackWaveformDamage class=ForceFeedbackWaveform
        Samples=/* Array type was not detected. */
    object end
    // Reference: ForceFeedbackWaveform'Default__FoxDamageType.ForceFeedbackWaveformDamage'
    DamagedFFWaveform=ForceFeedbackWaveformDamage
    begin object name=ForceFeedbackWaveformDeath class=ForceFeedbackWaveform
        Samples=/* Array type was not detected. */
    object end
    // Reference: ForceFeedbackWaveform'Default__FoxDamageType.ForceFeedbackWaveformDeath'
    KilledFFWaveform=ForceFeedbackWaveformDeath
}